#
# web page scraping program
# designed for http://finance.yahoo.com/
# but can be easily modified for other 
# websites.
#
# (C) 2004, Particle 
#

use IO::Socket;

@scrapes = (
    { name=>'Last Trade', scrape=>'Last Trade'},
    { name=>'Trade Time', scrape=>'Trade Time'},
    { name=>'Price Change', scrape=>'Change:'},
    { name=>'Previous Close', scrape=>'Prev Close:'},
    { name=>'Open Price', scrape=>'Open:'},
    { name=>'Bid Price', scrape=>'Bid:'},
    { name=>'Asking Price', scrape=>'Ask:'},
    { name=>'1 Year Target Estimate', scrape=>'1y Target Est:'},
    { name=>'Day\'s Range', scrape=>'Day\'s Range:'},
    { name=>'52 Week Range', scrape=>'52wk Range:'},
    { name=>'Volume', scrape=>'Volume:'},
    { name=>'Average Volume (3 months)', scrape=>'Avg Vol (3m)'},
    { name=>'Market Capitalization', scrape=>'Market Cap'},
    { name=>'P/E (ttm)', scrape=>'P/E (ttm)'},
    { name=>'EPS (ttm)', scrape=>'EPS (ttm)'},
    { name=>'Div & Yield', scrape=>'Div & Yield'},
);

%stocks = (
    '^DJI' => 'DJ INDU AVERAGE',
    '^NDX' =>  'NASDAQ 100',
    MSFT => 'Microsoft :-/',
    ORCL => Oracle,
    IBM => IBM,
    SUNW => 'Sun Microsystems',
    INTC => Intel,
    YHOO => Yahoo,
    GOOG => Google,
    SCOX => ':-(',
);

for $stock (sort keys %stocks){
    $_ = webget("http://finance.yahoo.com/q?s=$stock");
    s|<\/?small>||gs;
    s|<.*?>|~|gs;
    s|\&nbsp;||gs;
    s|\&amp;|&|gs;
    
    print "stock: $stock; $stocks{$stock}\n";
    for $scrape (@scrapes){
        my $data = scrape($scrape->{scrape});
        print "\t".$scrape->{name}.
            ": ".scrape($scrape->{scrape})."\n" if $data;
    }
}

sub scrape {
    my ($str) = @_;
    m/\Q$str\E.*?~?.*?([^~]{2,})/is;
    return $1;
}

sub webget {
    my ($url) = @_;
    $url =~ m|http://(.*?)(:\d+)?(/.*)|;
    my ($host,$doc) = ($1,$3);
    my $EOL = "\015\012";
    my $BLANK = $EOL x 2;
	$remote = IO::Socket::INET->new(Proto => "tcp",
					 PeerAddr  => $host,
					 PeerPort  => "http(80)",
			  );
    $remote->autoflush(1);
	print $remote "GET $doc HTTP/1.1" . $EOL;
    print $remote "Host: $host" . $BLANK;
    my $content = join '',<$remote>;
    close $temote;
    return $content;
}
